package jp.gr.java_conf.a0.file;

import java.io.File;
import java.io.FilenameFilter;

import jp.gr.java_conf.a0.debug.Debug;


public class ExtensionFilenameFilter implements FilenameFilter
{
	public ExtensionFilenameFilter(String anExtension)
	{
		Debug.assert(anExtension == null);
		if (!anExtension.startsWith(".")) {
			anExtension = "." + anExtension;
		}
		this.extension = anExtension;
		Debug.println("ExtensionFilenameFilter(): extension: " + this.extension);
	}
	/**
	 * Return true if aName is directory or aName ends with specified extension.
	 * Return false else.
	 */
	public boolean accept(File aDir, String aName)
	{
		Debug.println("ExtensionFilenameFilter.accespt(): dir: " + aDir + ", name: " + aName);
		if (aName.endsWith(extension)) {
			return true;
		}
		File tmp = new File(aDir.getAbsolutePath()  + File.separator + aName);
		return tmp.isDirectory();
	}
	private final String extension;
}
