package jp.gr.java_conf.a0.file;

import java.io.File;
import java.io.FilenameFilter;
import java.util.Vector;

import jp.gr.java_conf.a0.debug.Debug;


public class FileIterator
{
	public FileIterator(File aDir, boolean aRecursive, FilenameFilter aFilter)
	{
		this.rootdir = aDir;
		this.recursive = aRecursive;
		this.filter = aFilter;
		Debug.assert(!aDir.isDirectory());
		this.lookupFiles();
	}
	public FileIterator(File aDir, boolean aRecursive)
	{
		this(aDir, aRecursive, new DefaultFilenameFilter());
	}
	private void lookupFiles()
	{
		String[] children = this.rootdir.list(this.filter);
		File target = null;
		File roottmp = null;
		for (int i = 0; i < children.length; i++) {
			target = new File(this.rootdir.getAbsolutePath() +
							  File.separator + children[i]);
			if (target.isFile()) {
Debug.println("FileIterator.lookFiles(): add target: " + target);
				this.files.addElement(target);
				continue;
			}
			if (target.isDirectory() && recursive) {
				roottmp = this.rootdir;
				this.rootdir = target;
				this.lookupFiles();
				this.rootdir = roottmp;
			}
		}
	}
	
	public boolean hasMoreFiles()
	{
		return(this.files.size() > index);
	}
	public File nextFile()
	{
		return((File)this.files.elementAt(index++));
	}
	public void reset()
	{
		this.index = 0;
	}


	private File rootdir;
	private boolean recursive;
	private FilenameFilter filter;
	private final Vector files = new Vector();
	private int index = 0;
}


class DefaultFilenameFilter implements FilenameFilter
{
	public boolean accept(File aDir, String aName)
	{
		return true;
	}
}
