package jp.gr.java_conf.a0.jdh.gui;

import java.util.Hashtable;
import java.util.Enumeration;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import jp.gr.java_conf.a0.jdh.parser.comment.CommentBody;
import jp.gr.java_conf.a0.jdh.parser.comment.CommentTag;
import jp.gr.java_conf.a0.jdh.parser.source.JavaDocHolder;

import jp.gr.java_conf.a0.debug.Debug;

//public class JavaDocNode extends ClassTreeNode
public abstract class JavaDocNode extends ClassTreeNode
{
	public JavaDocNode(JavaDocHolder aHolder, SourceFileNode aFileNode)
	{
		super(aHolder);
		this.fileNode = aFileNode;
	}
//	private JavaDocHolder javaDoc;

	protected void checkState()
	{
		//Debug.println("JavaDocNode.checkState(): START:"+getSignature());	
		CommentTag tag = null;
		int state = 0;
		Enumeration tags = this.getCommentBody().getAllTags();
		while (tags.hasMoreElements()) {
			tag = (CommentTag)tags.nextElement();
			state = tag.getState();
			if ((state & STATE_CHANGED) != 0) {
				this.setChanged(true);
				if (this.isInvalid()) {
					// ȏstateς邱Ƃ͂Ȃ
					break;
				}
			}
			if ((state & STATE_INVALID) != 0) {
				this.setInvalid(true);
				if (this.isChanged()) {
					// ȏstateς邱Ƃ͂Ȃ
					break;
				}
			}
		}
		if (state == STATE_OK) {
			this.releaseCommentBody();// \[X
		}

		// qm[h`FbN
		Enumeration enum = this.children();
		while (enum.hasMoreElements()) {
			((JavaDocNode)enum.nextElement()).checkState();
		}
	}
	protected void checkStateInvalid()
	{
		this.setInvalid(false);
		CommentTag tag = null;
		int state = 0;
		Enumeration tags = this.getCommentBody().getAllTags();
		while (tags.hasMoreElements()) {
			tag = (CommentTag)tags.nextElement();
Debug.println("JavaDocNode.checkStaeInvalid(): tag: " + tag.getClass().getName());
state = tag.getState();
			if ((state & STATE_INVALID) != 0) {
				this.setInvalid(true);
				break;
			}
		}
		this.fileNode.setInvalid(this.isInvalid(), this);
	}
	public String getToolTipText()
	{
		if (CurrentProperties.displaysTooltipParam()) {
			// ̏܂߂ĕ\
			return(getSignature());
		} else {
			return(toString());
		}
	}
	public Icon getIcon(boolean anExpanded)
	{
		return(ICONS[this.getAccessFlag() & 0x07]);
	}
	protected void setInvalid(boolean aFlag)
	{
		super.setInvalid(aFlag);
		this.fileNode.setInvalid(aFlag, this);
	}
	/*
	protected void setInvalid(boolean aFlag, CommentTag aTag)
	{
		if (aFlag) {
			this.invalidTags.put(aTag, aTag);
			this.fileNode.setInvalid(aFlag, this);
		} else {
			this.invalidTags.remove(aTag);
			if (!this.isInvalid()) {
				this.fileNode.setInvalid(false, this);
			}
		}
	}
	public boolean isInvalid() {return(this.invalidTags.size() != 0);}
	*/
	protected void setChanged(boolean aFlag)
	{
		super.setChanged(aFlag);
		this.fileNode.setChanged(aFlag, this);
	}
	//protected void notifyReflecting()
	protected void reflect()
	{
		this.reflectToToken();
		this.setChanged(false);
	}
	private void reflectToToken()
	{
		if (this.editingBody != null) {
			this.getCommentBody().setBody(this.editingBody);
			this.editingBody = null;
		}
		this.getJavaDocHolder().reflectToJavaDocToken();
		Enumeration tags = this.getCommentBody().getAllTags();
		while (tags.hasMoreElements()) {
			((CommentTag)tags.nextElement()).setFlag(STATE_CHANGED, false);
		}
	}
	protected void save()
	{
		this.getSourceFileNode().save();
	}
	/**
	 * ҏWobt@擾B̏ꍇ̓p[XʁiCommentBodyj擾B
	 */
	public String getEditingBody()
	{
Debug.println("JavaDocNode.getEditingBody(): START");
		if (this.editingBody == null) {
Debug.println("JavaDocNode.getEditingBody(): editingBody was null.");
			this.editingBody = this.getJavaDocHolder().getCommentBody().getBody();
Debug.println("JavaDocNode.getEditingBody(): editingBody: " + editingBody);
		}
		return(this.editingBody);
	}
	/**
	 * ҏWobt@ɕZbgB
	 * ReflectɂāACommentBodyɔfĂȂ΁A
	 * t@Co͂ȂB
	 */
	public void setEditingBody(String aBody)
	{
Debug.println("JavaDocNode.setEditingBody(): START aBody: " + aBody);
		if (this.editingBody == null) {
Debug.println("JavaDocNode.setEditingBody(): editingBody is null.");
			return;
		}
		if (aBody == null) {
			return;
		}
		if (this.editingBody.equals(aBody)) {
			// if not modified, don't set body nor flags.
			return;
		}
		this.editingBody = aBody;
		this.setChanged(true);
	}


	
// Accessor
	public int getAccessFlag()		{return(this.getJavaDocHolder().getAccessFlag());}
	/** ToolTipManager Ăяo */
	public String getSignature()	{return(this.getJavaDocHolder().getSignature());}
	public JavaDocHolder getJavaDocHolder()	{return((JavaDocHolder)super.userObject);}
	//public CommentBody getCommentBody()	{return(this.getJavaDocHolder().getCommentBody());}
	protected CommentBody getCommentBody()	{return(this.getJavaDocHolder().getCommentBody());}
	private void releaseCommentBody(){this.getJavaDocHolder().releaseCommentBody();}
	public int getTagCount() {return(this.getCommentBody().getTagCount());}
	public CommentTag getTagAt(int index) {return(this.getCommentBody().getTagAt(index));}
	public void setTagAt(CommentTag aTag, int index)
	{this.getCommentBody().setTagAt(aTag, index);}
	public void insertTagAt(CommentTag aTag, int index)
	{
		this.getCommentBody().insertTagAt(aTag, index);
		Debug.println("JavaDocNode.insertTagAt(): fire! index: " + index);
		MainWindow.getInstance().getEditPane().getTagTable().getTagTableModel().
			fireTableRowsInserted(index, index);
	}
	public CommentTag removeTagAt(int index)
	{return(this.getCommentBody().removeTagAt(index));}
	public void addTag(CommentTag aTag)
	{this.getCommentBody().addTag(aTag);}
	public void removeTag(CommentTag aTag)
	{this.getCommentBody().removeTag(aTag);}
	protected SourceFileNode getSourceFileNode(){return(this.fileNode);}
	

// Fields
	private final SourceFileNode fileNode;
	private String editingBody = null;
	
	public static final int STATE_OK = CommentTag.STATE_OK;
	public static final int STATE_INVALID = (CommentTag.STATE_INVALID |
											 CommentTag.STATE_CONTENTS_CHANGED);
	public static final int STATE_CHANGED = (CommentTag.STATE_EDITED |
											 CommentTag.STATE_INSERTED |
											 CommentTag.STATE_EXTRA);

	private static final ImageIcon[] ICONS = {
		StaticProperties.getImage("images/public.gif"),
		StaticProperties.getImage("images/protected.gif"),
		StaticProperties.getImage("images/package.gif"),
		StaticProperties.getImage("images/private.gif"),
		StaticProperties.getImage("images/public_f.gif"),
		StaticProperties.getImage("images/protected_f.gif"),
		StaticProperties.getImage("images/package_f.gif"),
		StaticProperties.getImage("images/private_f.gif")
	};
	
	// XXX
	public static final JavaDocNode DUMMY_NODE = new JavaDocNode(JavaDocHolder.DUMMY_HOLDER, null) {
		protected void checkState(){}
		public int getAccessFlag()	
		{
			return(0);
		}
		public String getSignature()
		{
			return("");
		}
		public JavaDocHolder getJavaDocHolder()
		{
			return(JavaDocHolder.DUMMY_HOLDER);
		}
		/*
		public CommentBody getCommentBody()
		{
			//Debug.println("getCommentBody(): " + this.body);
			//return(this.body);
			return(CommentBody.DUMMY_BODY);
		}
		//private final CommentBody body = new CommentBody();
		*/
		protected CommentBody getCommentBody()		{return(CommentBody.DUMMY_BODY);}
		public String getEditingBody() {return(CommentBody.DUMMY_BODY.getBody());}
		public void setEditingBody(String s) {;}
	};
}
