package jp.gr.java_conf.a0.jdh.parser.test;

import jp.gr.java_conf.a0.jdh.parser.*;
import jp.gr.java_conf.a0.jdh.parser.source.*;
import jp.gr.java_conf.a0.jdh.parser.comment.*;
import java.util.*;

public class TestSourceCodeParser
{
	public static void main(String[] args) 
	{
		SourceCodeParser parser;
		if (args.length == 0) {
		        System.out.println("Java Parser Version 1.1:  Reading from standard input . . .");
		        parser = new SourceCodeParser(System.in);
		} else if (args.length == 1) {
		        System.out.println("Java Parser Version 1.1:  Reading from file " + args[0] + " . . .");
		        try {
		                parser = new SourceCodeParser(new java.io.FileInputStream(args[0]));
		        } catch (java.io.FileNotFoundException e) {
		                System.out.println("Java Parser Version 1.1:  File " + args[0] + " not found.");
		                return;
		        }
		} else {
		        System.out.println("Java Parser Version 1.1:  Usage is one of:");
		        System.out.println("         java SourceCodeParser < inputfile");
		        System.out.println("OR");
		        System.out.println("         java SourceCodeParser inputfile");
		        return;
		}
		ClassDecl[] cds = null;
		try {
		        cds = parser.CompilationUnit();
		        System.out.println("Java Parser Version 1.1:  Java program parsed successfully.");
		} catch (ParseException e) {
		        System.out.println(e.getMessage());
		        System.out.println("Java Parser Version 1.1:  Encountered errors during parse.");
		}

		// test
		test(args[0], cds[0]);
	}


	private static void test(String aFileName, ClassDecl aCD)
	{
		//System.out.println("Class ===>>>");
		//aCD.parse();
//		System.out.println(aCD.getJavaDocToken().image);
		//System.out.println("Class <<<===");
		
		JavaDocHolder h = null;
		Enumeration enum = aCD.getClassBlock().getHolderVec().elements();
		while(enum.hasMoreElements()) {
			//System.out.println("===>>>");
			h = (JavaDocHolder)enum.nextElement();
			System.out.println(h.getSignature());
			//System.out.println(h.getJavaDocToken().image);
			//System.out.println("<<<===");
		}
	}
}
